/* $Id: pgrpmlib.c,v 1.2 2005/04/19 18:09:42 nanardon Exp $ */
#include <postgres.h>
#include <fmgr.h>

#include <rpm/rpmlib.h>

#include "pgrpm.h"
#include "pgrpmlib.h"

PG_FUNCTION_INFO_V1(rpmtagname);

Datum
rpmtagname(PG_FUNCTION_ARGS)
{
    rpmTag tag = PG_GETARG_INT32(0);
    const char * res = tagName(tag);
    text * tres = (text*) palloc(VARHDRSZ+strlen(res));
    VARATT_SIZEP(tres) = strlen(res)+VARHDRSZ;
    memcpy(VARDATA(tres), res, strlen(res));
    PG_RETURN_TEXT_P(tres);
}

PG_FUNCTION_INFO_V1(rpmtagvalue);

Datum
rpmtagvalue(PG_FUNCTION_ARGS)
{
    char *tagname = GET_STR(PG_GETARG_TEXT_P(0));
    PG_RETURN_INT32(tagValue(tagname));
}
